//
//  HiliteWindow.m
//  Ivanhoe
//
//  Created by Stephane Sudre on 6/26/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "HiliteWindow.h"

@implementation HiliteWindow

- (id) initForView:(NSView *) inView withFrame:(NSRect) inFrame
{
	if (inView!=nil)
	{
		inFrame=[inView convertRect:inFrame toView:nil];
		
		inFrame.origin=[[inView window] convertBaseToScreen:inFrame.origin];
			
		self=[super initWithContentRect:inFrame styleMask:NSBorderlessWindowMask backing:NSBackingStoreBuffered defer:YES];
		
		if (self!=nil)
		{
			ICHighlightView * tView;
			NSView * tContentView;
			
			[self setIgnoresMouseEvents:YES];
			
			[self setBackgroundColor: [NSColor clearColor]];
			
			[self setOpaque:NO];
			
			tContentView=[self contentView];
			
			tView=[[ICHighlightView alloc] initWithFrame:[tContentView bounds]];
			
			if (tView!=nil)
			{
				[tContentView addSubview:tView];
				
				[tView release];
			}
			else
			{
				self=nil;
			}
		}
	}
	else
	{
		self=nil;
	}
	
	return self;
}

- (id) initForView:(NSView *) inView
{
	return [self initForView:inView withFrame:[inView frame]];
}

@end

@implementation ICHighlightView

- (void) drawRect:(NSRect) inRect
{
    NSBezierPath * tPath;
	
	tPath=[NSBezierPath bezierPathWithRoundedRect:NSInsetRect([self bounds],2.0f,2.0f) radius:8.0f];
	
	if (tPath!=nil)
	{
		[tPath setLineWidth:3.0f];
		
		[[NSColor alternateSelectedControlColor] set];
		
		[tPath stroke];
	}
}

@end