#import "ICArcButton.h"

#define ICARC_BUTTON_HEIGHT	23.0

#define ICARC_BUTTON_LINE_WIDTH		2.0f


@implementation ICArcButton

- (BOOL) isFlipped
{
	return NO;
}

- (void) setRight:(BOOL) inRight
{
	right_=inRight;
}

- (NSBezierPath *) bezierPath
{
	NSRect tBounds;
	NSBezierPath * tBezierPath;
	CGFloat tRadius;
	
	tBounds=NSInsetRect([self bounds],ICARC_BUTTON_LINE_WIDTH+1.0f,ICARC_BUTTON_LINE_WIDTH+1.0f);
	
	tRadius=NSWidth(tBounds);
	
	tBezierPath=[NSBezierPath bezierPath];
	
	if (right_==YES)
	{
		
	}
	else
	{
		[tBezierPath moveToPoint:NSMakePoint(NSMinX(tBounds),NSMaxY(tBounds))];
		
		[tBezierPath appendBezierPathWithArcWithCenter:NSMakePoint(NSMaxX(tBounds),NSMaxY(tBounds))
												radius:tRadius
										    startAngle:180.0f
											  endAngle:270.0f
											 clockwise:NO];
											 
		[tBezierPath lineToPoint:NSMakePoint(NSMaxX(tBounds),NSMinY(tBounds)+ICARC_BUTTON_HEIGHT)];
		
		[tBezierPath appendBezierPathWithArcWithCenter:NSMakePoint(NSMaxX(tBounds),NSMaxY(tBounds))
												radius:(tRadius-ICARC_BUTTON_HEIGHT)
										    startAngle:270.0f
											  endAngle:180.0f
											 clockwise:YES];
											 
		[tBezierPath closePath];
	}
	
	return tBezierPath;
}

- (void) drawRect:(NSRect) inRect
{
	NSBezierPath * tBezierPath;
	
	//tBounds=NSInsetRect([self bounds],ICPRESENTATION_PLUGIN_BUTTON_LINE_WDITH,ICPRESENTATION_PLUGIN_BUTTON_LINE_WDITH);
	
	/*if ([self isEnabled]==YES)
	{
		[[NSColor colorWithDeviceWhite:0.25f alpha:1.0f] set];
	}
	else
	{
		[[NSColor colorWithDeviceWhite:0.65f alpha:1.0f] set];
	}*/
	
	tBezierPath=[self bezierPath];
	
	[[NSColor colorWithDeviceWhite:0.75f alpha:1.0f] set];
	
	[tBezierPath setLineWidth:ICARC_BUTTON_LINE_WIDTH];
	
	[tBezierPath stroke];
}

- (void) mouseDown:(NSEvent *) inEvent
{
	/*if ([self isEnabled]==YES)
	{
		NSRect tBounds;
		NSBezierPath * tBezierPath;
		NSPoint tMouseLoc=[self convertPoint:[inEvent locationInWindow] fromView:nil];
		
		tBounds=[self bounds];
		
		tBezierPath=[NSBezierPath bezierPathWithOvalInRect:tBounds];
		
		[tBezierPath setLineWidth:ICPRESENTATION_PLUGIN_BUTTON_LINE_WDITH];
		
		if ([tBezierPath containsPoint:tMouseLoc]==YES)
		{
			pushed_=YES;
				
			[self setNeedsDisplay:YES];
		}
	}*/
}

- (void) mouseDragged:(NSEvent *) inEvent
{
    /*if ([self isEnabled]==YES)
	{
		NSRect tBounds;
		NSBezierPath * tBezierPath;
		NSPoint tMouseLoc=[self convertPoint:[inEvent locationInWindow] fromView:nil];
		
		tBounds=[self bounds];
		
		tBezierPath=[NSBezierPath bezierPathWithOvalInRect:tBounds];
		
		[tBezierPath setLineWidth:ICPRESENTATION_PLUGIN_BUTTON_LINE_WDITH];
		
		if ([tBezierPath containsPoint:tMouseLoc]==YES)
		{
			if (pushed_==NO)
			{
				pushed_=YES;
				
				[self setNeedsDisplay:YES];
			}
		}
		else
		{
			if (pushed_==YES)
			{
				pushed_=NO;
				
				[self setNeedsDisplay:YES];
			}
		}
	}*/
}

- (void) mouseUp:(NSEvent *) inEvent
{
    /*if ([self isEnabled]==YES)
	{
		NSRect tBounds;
		NSBezierPath * tBezierPath;
		NSPoint tMouseLoc=[self convertPoint:[inEvent locationInWindow] fromView:nil];
		
		pushed_=NO;
		
		tBounds=[self bounds];
		
		tBezierPath=[NSBezierPath bezierPathWithOvalInRect:tBounds];
		
		[tBezierPath setLineWidth:ICPRESENTATION_PLUGIN_BUTTON_LINE_WDITH];
		
		if ([tBezierPath containsPoint:tMouseLoc]==YES)
		{
			[self sendAction:[self action] to:[self target]];
			
			[self setNeedsDisplay:YES];
		}
	}*/
}

@end
