/*
 Copyright (c) 2008-2010, Stephane Sudre
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 - Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <Foundation/Foundation.h>
#import "TreeNode.h"

#define ICBUILDTREE_TYPE_ROOT							0

#define ICBUILDTREE_TYPE_PROJECT						1

#define ICBUILDTREE_TYPE_DISTRIBUTION_SCRIPT			2

#define ICBUILDTREE_TYPE_DISTRIBUTION_PACKAGE_PROJECT	3

#define ICBUILDTREE_TYPE_DISTRIBUTION_PACKAGE			4

#define ICBUILDTREE_TYPE_PACKAGE						5

#define ICBUILDTREE_TYPE_STEP							6

#define ICBUILDTREE_TYPE_STEP_PARENT					7

#define ICBUILDTREE_TYPE_ERROR_DESCRIPTION				8

#define ICBUILDTREE_TYPE_CONCLUSION						9


#define ICBUILDTREE_STATUS_RUNNING						0

#define ICBUILDTREE_STATUS_SUCCESS						1

#define ICBUILDTREE_STATUS_FAILURE						2

#define ICBUILDTREE_NODE(n)		((ICBuildTreeNode*) n)

#define ICBUILDNODE_DATA(n) 	((ICBuildNodeData *)[ICBUILDTREE_NODE((n)) nodeData])

#if MAC_OS_X_VERSION_MAX_ALLOWED < MAC_OS_X_VERSION_10_5
@interface ICBuildNodeData: TreeNodeData
#else
@interface ICBuildNodeData: NSObject
#endif
{
	int type_;

    int status_;
	
    NSString * title_;
	
	NSString * subTitle_;
}

+ (id) nodeOfType:(int) inType withTitle:(NSString *) inTitle subTitle:(NSString *) inSubTitle status:(int) inStatus;

- (id) initWithType:(int) inType title:(NSString *) inTitle subTitle:(NSString *) inSubTitle status:(int) inStatus;

+ (id) rootNode;

- (BOOL) isLeaf;


- (int) type;

- (void) setType:(int) inType;

- (int) status;

- (void) setStatus:(int) inStatus;


- (NSString *) title;

- (void) setTitle:(NSString *) inTitle;

- (NSString *) subTitle;

- (void) setSubTitle:(NSString *) inSubTitle;


@end

@interface ICBuildTreeNode : TreeNode
{

}

+ (id) buildTree;

@end
