/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import <Foundation/Foundation.h>

#import "ICInstallationTypeTree.h"

extern NSString * const ICCHOICE_ENABLED_DEPENDENCY_AVAILABILITY;

extern NSString * const ICCHOICE_SELECTED_DEPENDENCY_AVAILABILITY;

extern NSString * const ICCHOICE_ENABLED_DEPENDENCIES;

extern NSString * const ICCHOICE_SELECTED_DEPENDENCIES;

extern NSString * const ICCHOICE_IS_GROUP;

extern NSString * const ICCHOICE_NODE;

extern NSString * const ICCHOICE_UUID;

extern NSString * const ICCHOICE_STATE_OBJECT;

@interface NSString (NumericComparison)

- (NSComparisonResult) compareNumeric:(NSString *) inString;

@end

@interface ICChoiceUtilities : NSObject
{

}

+ (BOOL) isEnabledStateConstantForNode:(ICInstallationTypeTreeNode *) inTreeNode;

+ (void) addChoiceDependencyForBranch:(NSDictionary *) inBranch toArray:(NSMutableArray *) inMutableArray;

+ (NSMutableArray *) enabledDependenciesFromDependencyDictionary:(NSDictionary *) inDependencyDictionary;

+ (NSMutableArray *) selectedDependenciesFromDependencyDictionary:(NSDictionary *) inDependencyDictionary;

+ (void) addDependenciesOfNode:(ICInstallationTypeTreeNode *) inNode toDictionary:(NSMutableDictionary *) inDictionary;

+ (NSMutableDictionary *) allDependenciesForTree:(ICInstallationTypeTreeNode *) inTreeNode;


+ (NSMutableDictionary *) availableDependenciesDictionaryForEnabledStateOfGroupNode:(ICInstallationTypeTreeNode *) inTreeNode;

+ (NSMutableDictionary *) availableDependenciesDictionaryForEnabledStateOfLeafNode:(ICInstallationTypeTreeNode *) inTreeNode skipEnabledIfConstant:(BOOL) inSkipEnabled;

+ (NSMutableDictionary *) availableDependenciesDictionaryForEnabledStateOfLeafNode:(ICInstallationTypeTreeNode *) inTreeNode;

+ (NSMutableDictionary *) availableDependenciesDictionaryForSelectedStateOfLeafNode:(ICInstallationTypeTreeNode *) inTreeNode;



+ (NSMutableArray *) availableListOfChoicesFromAvailableDependenciesDictionary:(NSDictionary *) inDictionary;

+ (NSMutableDictionary *) availableChoicesDictionaryFromAvailableDependenciesDictionary:(NSDictionary *) inDictionary;

+ (NSMutableDictionary *) UUIDDictionaryFromAvailableDependenciesDictionary:(NSDictionary *) inDictionary;

@end
