/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICFileHierarchyInspectorController.h"

#import "ICFileHierarchyInspectorController+Constants.h"

#import "ICFileTree.h"

#include <sys/stat.h>

#import "ICArchitectureUtilities.h"

@interface ICFileHierarchyInspectorSelectionController : ICFileHierarchyInspectorController
{
	IBOutlet id IBfileIcon_;
	
	IBOutlet id IBfileBigName_;
	
	IBOutlet id IBfileLastModifiedDate_;
	
	IBOutlet id IBfileArchitecturesLabel_;
	
	IBOutlet id IBfileArchitectures_;
	
	IBOutlet id IBfileType_;
	
	IBOutlet id IBpathType_;
	
	IBOutlet id IBnonEditablePathType_;
	
	IBOutlet id IBfileSource_;
	
	IBOutlet id IBfileDestination_;
	
	
	IBOutlet id IBtabView_;
	
		// Attributes
	
	IBOutlet id IBfileEditableName_;
	
	IBOutlet id IBfileSelectableName_;
	
	IBOutlet id IBfilePermissions_;
	
	IBOutlet id IBfilePermissionsArray_;
	
	IBOutlet id IBfileSpecialBitsArray_;
	
	// Data
	
	NSWorkspace * sharedWorkspace_;
	
	NSArray * array_;
	
	NSDateFormatter * dateFormatter_;
	
	NSInteger cachedPathTypeIndex_;
	
	int cachedFilePermissions_;
	
	int mixedFilePermission_;
	
	BOOL canEditFilePermissions_;

	char cachedStatType_;
}

+ (void) runRealFileIconsCacheMaintenance;

- (void) initializeWithArray:(NSMutableArray *) inArray forDocument:(id) inDocument;

- (void) setFileNameEditable:(BOOL) inEditable;

- (NSImage *) iconForTreeNode:(ICFileTree *) inFileTree;

- (void) updateSingleSelection;

- (void) updateMultipleSelection;

- (IBAction) setFolderName:(id) sender;

- (IBAction) switchPathType:(id) sender;

- (IBAction) revealSourceInFinder:(id) sender;

- (IBAction) switchPermissions:(id) sender;

- (void) postAttributesDidChangeNotification;

@end
