/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICLanguagePopupButtonCell.h"

@implementation ICLanguagePopupButtonCell

- (void) drawWithFrame:(NSRect) cellFrame inView:(NSView *) controlView
{
	NSMenuItem * tMenuItem;
	NSRect tDestinationRect;
	NSBezierPath * tPath;
	tMenuItem=[self selectedItem];
	CGFloat tMiddleY;
	CGFloat tMinX;
	
	tMinX=NSMinX(cellFrame);
	tMiddleY=NSMidY(cellFrame);
		
	tDestinationRect.origin.x=tMinX+18.0f;
	
	if (tMenuItem!=nil)
	{
		NSImage * tImage;
		
		tImage=[tMenuItem image];
		
		if (tImage!=nil)
		{
			NSRect tImageRect;
			tImageRect.origin=NSZeroPoint;
			tImageRect.size=[tImage size];
			
			tDestinationRect.size=tImageRect.size;
			
			tDestinationRect.origin.x=tMinX+10.0f;
			tDestinationRect.origin.y=_CGFloatRound(tMiddleY+tDestinationRect.size.height*0.5f-1.0f);
			
			if ([self isEnabled]==YES)
			{
				[tImage compositeToPoint:tDestinationRect.origin fromRect:tImageRect operation:NSCompositeSourceOver fraction:1.0f];
			}
			else
			{
				[tImage compositeToPoint:tDestinationRect.origin fromRect:tImageRect operation:NSCompositeSourceOver fraction:0.5f];
			}
			
			tDestinationRect.origin.x+=tImageRect.size.width+6;
		}
	}
	
	// Draw the Arrow
	
	// Top Arrow
	
	tPath=[NSBezierPath bezierPath];
	
	if ([self isEnabled]==YES)
	{
		[[NSColor colorWithDeviceWhite:0.15f alpha:1.0f] set];
	}
	else
	{
		[[NSColor colorWithDeviceWhite:0.15f alpha:0.5f] set];
	}
	
	if (tPath!=nil)
	{
		[tPath moveToPoint:NSMakePoint(tDestinationRect.origin.x,_CGFloatRound(tMiddleY))];
		[tPath lineToPoint:NSMakePoint(tDestinationRect.origin.x+5.0f,_CGFloatRound(tMiddleY))];
		[tPath lineToPoint:NSMakePoint(tDestinationRect.origin.x+2.5f,_CGFloatRound(tMiddleY+3.5f))];
		[tPath closePath];
		
		[tPath fill];
		
		[tPath removeAllPoints];
	}
	
	if (tPath!=nil)
	{
		
		
		[tPath moveToPoint:NSMakePoint(tDestinationRect.origin.x,_CGFloatRound(tMiddleY)-2.0f)];
		[tPath lineToPoint:NSMakePoint(tDestinationRect.origin.x+5.0f,_CGFloatRound(tMiddleY)-2.0f)];
		[tPath lineToPoint:NSMakePoint(tDestinationRect.origin.x+2.5f,_CGFloatRound(tMiddleY)-5.5f)];
		[tPath closePath];
		
		[tPath fill];
	}
}

@end
