#import "ICMultiplePackagesSelectionController.h"


@implementation ICMultiplePackagesSelectionController

+ (ICMultiplePackagesSelectionController *) multiplePackagesSelectionController
{
	ICMultiplePackagesSelectionController * nController=nil;
    
    nController=[ICMultiplePackagesSelectionController alloc];
    
    if (nController!=nil)
    {
        if ([NSBundle loadNibNamed:@"MultiplePackagesSelection_Pane" owner:nController]==NO)
        {
            NSBeep();
            
            NSRunCriticalAlertPanel([NSString stringWithFormat:NSLocalizedString(@"Packages can't find the \"%@\".nib resource file.",@"No comment"),@"MultiplePackagesSelection_Pane"],NSLocalizedString(@"Packages will stop running to avoid improper behavior.\nYou should check that the application has not been corrupted.",@"No comment"), nil,nil,nil);
            
            [NSApp terminate:nil];
        }
    }
    
    return [nController autorelease];
}

- (void) awakeFromNib
{
	// Register for Notifications
	
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(viewDidResize:) 
												 name:NSViewFrameDidChangeNotification 
											   object:IBview_];
}

#pragma mark -

- (void) viewDidResize:(NSNotification *) inNotification
{
	NSRect tFrame,tOldFrame;
	NSRect tBounds;
	
	tBounds=[IBview_ bounds];
	
	tFrame=tOldFrame=[IBlabelText_ frame];
	
	// Center horizontally
		
	tFrame.origin.x=_CGFloatRound(NSMidX(tBounds)-NSWidth(tFrame)*0.5f);
	
	// Center horizontally
		
	tFrame.origin.y=_CGFloatRound(NSMidY(tBounds)-NSHeight(tFrame)*0.5f);
	
	if (NSEqualRects(tFrame,tOldFrame)==NO)
	{
		[IBlabelText_ setFrame:tFrame];
	}
	
	
}

@end
