#import "ICSegmentedController.h"

#import "ICFileTree.h"

#import "ICDirectoryServicesManager.h"

#import "ICDocument.h"

#import "ICFileNameFormatter.h"

@interface ICPackageFilesController : ICSegmentedController
{
	IBOutlet id IBdefaultLocationPath_;
	
	IBOutlet id IBsetButton_;
	
	IBOutlet id IBoutlineView_;
	
	IBOutlet id IBaddButton_;
	
	IBOutlet id IBremoveButton_;
	
	IBOutlet id IBinspectorView_;
	
	// Permissions & Reference Dialog
	
	IBOutlet id IBownerAndGroup_;
	
	IBOutlet id IBreferenceStyle_;
	
	// Data
	
	NSString * cachedPackageUUID_;
	
	NSUserDefaults * defaults_;
	
	ICDirectoryServicesManager * directoryServicesManager_;
	
	ICFileTree * fileTree_;
	
	ICFileTree * defaultLocation_;
	
	ICFileTree * parentFileTree_;
	
	BOOL hierarchyChanged_;
	
	ICFileNameFormatter * fileNameFormatter_;
	
	NSImage * genericFolderIcon_;
	
	NSImage * genericDisabledFolderIcon_;
	
	id emptySelectionInspectorController_;
	
	id selectionInspectorController_;
	
	id currentInspectorController_;
	
	id currentViewController_;
	
	BOOL cachedHighlightExcludedFiles_;
	
	ICFileBouncer * cachedFileBouncer_;
	
	NSMutableArray * internalDragArray_;
}

+ (ICPackageFilesController *) packageFilesController;

- (void) delayedHierarchyLoad:(id) sender;

- (IBAction)addFiles:(id)sender;

- (void) addFilesPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo;

- (void) beginFileSheet:(NSArray *) inFiles;

- (IBAction) endFileSheet:(id) sender;

- (void) fileSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;


- (BOOL) defaultRestoreForItem:(id) inItem;

- (void) restoreDisclosedStates;


- (void) archiveSelection;

- (void) restoreSelection;


- (IBAction) newFolder:(id) sender;

- (IBAction) expandAll:(id) sender;

- (void) delayedExpandAll:(id) inObject;

- (IBAction) expand:(id) sender;

- (void) delayedExpand:(id) inObject;

- (IBAction) expandOneLevel:(id) sender;

- (IBAction) contract:(id) sender;

- (IBAction) removeFile:(id)sender;

- (void) removeFileSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (IBAction) revealInFinder:(id) sender;

- (IBAction) setAsDefaultLocation:(id)sender;

- (IBAction) updateFiles:(id) sender;

- (void) _addFiles:(NSArray *) inFilesArray keepOwnerAndGroup:(BOOL) inKeepOwnerAndGroup referenceStyle:(int) inReferenceStyle;

// Notifications

- (void) folderNameShouldChange:(NSNotification *) inNotification;

- (void) fileAttributesDidChange:(NSNotification *) inNotification;

- (void) highlightExcludedFilesDidChange:(NSNotification *) inNotification;

@end
