/*
 Copyright (c) 2008-2010, Stephane Sudre
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 - Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import "ICFileHierarchyInspectorSelectionController.h"

@interface ICPackageFilesInspectorSelectionController : ICFileHierarchyInspectorSelectionController
{
	
		// Attributes
	
	IBOutlet id IBfileOwner_;
	
	IBOutlet id IBfileOwnerTextField_;
	
	IBOutlet id IBfileGroup_;
	
	IBOutlet id IBfileGroupTextField_;
	
		// Rules
		
	IBOutlet id IBallowDowngradeCheckbox_;
	
	IBOutlet id IBlocatorsArray_;
	
	IBOutlet id IBaddLocatorButton_;
	
	IBOutlet id IBeditLocatorButton_;
	
	IBOutlet id IBremoveLocatorButton_;
	
		// Scripts
		
	IBOutlet id IBpreInstallIcon_;
	
	IBOutlet id IBpreInstallName_;
	
	IBOutlet id IBpreInstallLastModifiedDate_;
	
	IBOutlet id IBpreInstallPathType_;
	
	IBOutlet id IBpreInstallRemoveButton_;
	
	IBOutlet id IBpostInstallIcon_;
	
	IBOutlet id IBpostInstallName_;
	
	IBOutlet id IBpostInstallLastModifiedDate_;
	
	IBOutlet id IBpostInstallPathType_;
	
	IBOutlet id IBpostInstallRemoveButton_;
		
		
	
	// Data
	
	NSTabViewItem * tabViewScriptsItem_;
	
	NSTabViewItem * tabViewBundleItem_;
	
	NSInteger cachedOwnerIndex_;
	
	NSInteger cachedGroupIndex_;
	
	
	id locatorController_;
	
	NSMutableArray * cachedLocators_;
	
	BOOL editLocatorMode_;
	
	
	NSInteger cachedPreInstallPathTypeIndex_;
	
	NSInteger cachedPostInstallPathTypeIndex_;
	
	
}

+ (ICPackageFilesInspectorSelectionController *) newController;

- (IBAction) switchOwner:(id) sender;

- (IBAction) switchGroup:(id) sender;



- (IBAction) switchAllowDowngrade:(id) sender;


- (IBAction) addLocator:(id) sender;

- (IBAction) editLocator:(id) sender;

- (IBAction) removeLocator:(id) sender;

- (void) removeLocatorsDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;

- (NSString *) uniqueLocatorNameWithBaseName:(NSString *) inBaseName;


- (void) updatePreInstallScriptWithPath:(NSString *) inPath;

- (IBAction) switchPreInstallPathType:(id) sender;

- (IBAction) setPreInstallScript:(id) sender;

- (void) setPreInstallScriptDidEnd:(NSOpenPanel *)sheet returnCode:(NSInteger)returnCode contextInfo:(void  *)contextInfo;

- (IBAction) removePreInstallScript:(id) sender;

- (void) removePreInstallScriptDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;


- (void) updatePostInstallScriptWithPath:(NSString *) inPath;

- (IBAction) switchPostInstallPathType:(id) sender;

- (IBAction) setPostInstallScript:(id) sender;

- (void) setPostInstallScriptDidEnd:(NSOpenPanel *)sheet returnCode:(NSInteger)returnCode contextInfo:(void  *)contextInfo;

- (IBAction) removePostInstallScript:(id) sender;

- (void) removePostInstallScriptDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;

// Notifications

- (void) windowStateDidChange:(NSNotification *) inNotification;

- (void) dropViewFilePathDidChange:(NSNotification *) inNotification;

@end
