/*
 Copyright (c) 2008-2010, Stephane Sudre
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 - Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import "ICPackageScriptsInspectorSelectionController.h"

@implementation ICPackageScriptsInspectorSelectionController

+ (ICPackageScriptsInspectorSelectionController *) newController
{
	ICPackageScriptsInspectorSelectionController * nController;
    
    nController=[ICPackageScriptsInspectorSelectionController alloc];
    
    if (nController!=nil)
    {
        if ([NSBundle loadNibNamed:@"ICScriptsSelectionInspectorView" owner:nController]==NO)
        {
            NSBeep();
            
            NSRunCriticalAlertPanel([NSString stringWithFormat:NSLocalizedString(@"Packages can't find the \"%@\".nib resource file.",@"No comment"),@"ICScriptsSelectionInspectorView"],NSLocalizedString(@"Packages will stop running to avoid improper behavior.\nYou should check that the application has not been corrupted.",@"No comment"), nil,nil,nil);
            
            [NSApp terminate:nil];
        }
    }
    
    return nController;
}

#pragma mark -

- (void) initializeWithArray:(NSMutableArray *) inArray forDocument:(id) inDocument
{
	[super initializeWithDictionary:nil forDocument:inDocument];
	
	array_=inArray;
	
	if (array_!=nil)
	{
		[array_ retain];
		
		if ([[IBpathType_ itemTitleAtIndex:0] isEqualToString:NSLocalizedString(@"Mixed",@"No comment")]==YES)
		{
			[IBpathType_ removeItemAtIndex:0];
		}
		
		if ([array_ count]==1)
		{
			[self updateSingleSelection];
		}
		else
		{
			[self updateMultipleSelection];
		}
	}
}

@end
