/*
 Copyright (c) 2008-2010, Stephane Sudre
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 
 - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 - Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import "ICPreferencePaneGeneralController.h"

#import "ICDocumentFormat+Constants.h"

@implementation ICPreferencePaneGeneralController

- (void) awakeFromNib
{
    id tObject;
	
	[super awakeFromNib];
	
	// Reference Style
	
	[IBdefaultReferenceStylePopUpButton_ removeItemAtIndex:0];
	
	tObject=[defaults_ objectForKey:ICPREFERENCES_GENERAL_DEFAULT_REFERENCE_STYLE];
	
	if (tObject==nil)
	{
		[defaults_ setInteger:ICDOCUMENT_PATH_TYPE_GLOBAL forKey:ICPREFERENCES_GENERAL_DEFAULT_REFERENCE_STYLE];
	}
}

- (void) updateWithDefaults
{
	NSInteger tDefaultTag;
	
	// Default Visibles Panes
	
	// Project
	
	tDefaultTag=[defaults_ integerForKey:ICPREFERENCES_GENERAL_DEFAULT_PROJECT_PANE];
	
	[IBvisibleProjectPanePopupButton_ selectItemWithTag:tDefaultTag];
	
	// Package
	
	tDefaultTag=[defaults_ integerForKey:ICPREFERENCES_GENERAL_DEFAULT_PACKAGE_PANE];
	
	[IBvisiblePackagePanePopupButton_ selectItemWithTag:tDefaultTag];
	
	// Package Standalone
	
	tDefaultTag=[defaults_ integerForKey:ICPREFERENCES_GENERAL_DEFAULT_PACKAGE_STANDALONE_PANE];
	
	[IBvisiblePackagePaneStandalonePopupButton_ selectItemWithTag:tDefaultTag];
	
	// Default Reference Style
	
	[IBdefaultReferenceStylePopUpButton_ selectItemAtIndex:[IBdefaultReferenceStylePopUpButton_ indexOfItemWithTag:[defaults_ integerForKey:ICPREFERENCES_GENERAL_DEFAULT_REFERENCE_STYLE]]];
}

#pragma mark -

- (IBAction) switchDefaultVisibleProjectPane:(id) sender
{
	NSInteger tTag;
	
	tTag=[[sender selectedItem] tag];
	
	[defaults_ setInteger:tTag forKey:ICPREFERENCES_GENERAL_DEFAULT_PROJECT_PANE];
}

- (IBAction) switchDefaultVisiblePackagePane:(id) sender
{
	NSInteger tTag;
	
	tTag=[[sender selectedItem] tag];
	
	[defaults_ setInteger:tTag forKey:ICPREFERENCES_GENERAL_DEFAULT_PACKAGE_PANE];
}

- (IBAction) switchDefaultVisiblePackageStandalonePane:(id) sender
{
	NSInteger tTag;
	
	tTag=[[sender selectedItem] tag];
	
	[defaults_ setInteger:tTag forKey:ICPREFERENCES_GENERAL_DEFAULT_PACKAGE_STANDALONE_PANE];
}

- (IBAction) switchDefaultReferenceStyle:(id) sender
{
	NSInteger tTag;
	
	tTag=[[IBdefaultReferenceStylePopUpButton_ selectedItem] tag];
	
	[defaults_ setInteger:tTag forKey:ICPREFERENCES_GENERAL_DEFAULT_REFERENCE_STYLE];
}

@end
