/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICDocumentSecondaryController.h"

#import "ICInstallationTypeTree.h"

@interface ICPresentationInspectorInstallationTypeChoiceDependencyController : ICDocumentSecondaryController
{
	IBOutlet id IBchoiceEnabledDependencyTextLabel_;

	IBOutlet id IBchoiceEnabledDependencyPopupButton_;
	
	IBOutlet id IBchoiceEnabledDependencyColonLabel_;
	
	IBOutlet id IBchoiceEnabledDependencyScrollView_;
	
	IBOutlet id IBchoiceEnabledDependencyView_;
	
	IBOutlet id IBchoiceSelectedDependencyTextLabel_;
	
	IBOutlet id IBchoiceSelectedDependencyScrollView_;
	
	IBOutlet id IBchoiceSelectedDependencyView_;
	
	IBOutlet id IBcloseView_;
	
	IBOutlet id IBcloseButton_;
	
	// Data
	
	ICInstallationTypeTreeNode * node_;
	
	NSMutableDictionary * availableEnabledDependenciesDictionary_;
	
	NSMutableDictionary * availableSelectedDependenciesDictionary_;
	
	NSMutableDictionary * enabledChoicesDictionary_;
	
	NSMutableDictionary * selectedChoicesDictionary_;
	
	NSMutableDictionary * UUIDsDictionary_;

	BOOL isGroup_;
	
	NSSize availableChoicesPopUpButtonSize_;
	
	NSSize operatorPopUpButtonSize_;
	
	NSSize comparatorPopUpButtonSize_;
	
	NSSize stateObjectPopUpButtonSize_;
	
	CGFloat leafWidth_;
	
	CGFloat branchWidth_;
}

- (IBAction) switchEnabledStateMode:(id) sender;

- (NSMutableDictionary *) defaultEnabledLeafDictionary;

- (NSMutableDictionary *) defaultSelectedLeafDictionary;

- (void) computePopupButtonSizes;

- (NSMenu *) enabledAvailableChoicesMenu;

- (NSMenu *) selectedAvailableChoicesMenu;

- (NSMenu *) operatorsMenu;

- (NSMenu *) comparatorsMenu;

- (NSMenu *) stateObjectsMenu;

- (void) computeViewSizeWithDictionary:(NSDictionary *) inDictionary maxY:(CGFloat *) inOutMaxY minX:(CGFloat *) outMinX midY:(CGFloat *) outMidY;

- (NSSize) optimizedSizeForDictionary:(NSDictionary *) inDictionary;

- (NSButton *) layoutView:(id) inView forDictionary:(NSDictionary *) inDictionary maxY:(CGFloat *) inOutMaxY minX:(CGFloat *) outMinX midY:(CGFloat *) outMidY;

- (void) refreshView;

- (BOOL) validateMenuItem:(NSMenuItem *) inMenuItem forDictionary:(NSDictionary *) inDictionary;

- (IBAction) switchOperator:(id) sender;

- (IBAction) switchEnabledChoice:(id) sender;

- (IBAction) switchSelectedChoice:(id) sender;

- (IBAction) switchComparator:(id) sender;

- (IBAction) switchEnabledStateObject:(id) sender;

- (IBAction) switchSelectedStateObject:(id) sender;

- (IBAction) addBranch:(id) sender;

- (IBAction) removeBranch:(id) sender;

- (void) switchBranches:(id) sender;


- (IBAction) closePane:(id) sender;

// Notifications

- (void) viewFrameDidChange:(NSNotification *) inNotification;

@end
