/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICDocumentSecondaryController.h"
#import "ICInstallationTypeTree.h"

@interface ICPresentationInspectorInstallationTypeChoiceSelectionController : ICDocumentSecondaryController
{
	IBOutlet id IBchoiceIcon_;
	
	IBOutlet id IBchoiceType_;
	
	IBOutlet id IBchoicePackageName_;
	
	IBOutlet id IBtabView_;
		
		// Attributes
	
	IBOutlet id IBtitleSection_;
	
	IBOutlet id IBtitleScrollView_;
	
	IBOutlet id IBtitleArray_;
	
	IBOutlet id IBtitleAddButton_;
	
	IBOutlet id IBtitleRemoveButton_;
	
	IBOutlet id IBdescriptionSection_;
	
	IBOutlet id IBdescriptionScrollView_;
	
	IBOutlet id IBdescriptionArray_;
	
	IBOutlet id IBdescriptionAddButton_;
	
	IBOutlet id IBdescriptionRemoveButton_;
	
	IBOutlet id IBchoiceExtendedAttributesSection_;
	
	IBOutlet id IBchoicePackageVisibility_;
	
	IBOutlet id IBchoicePackageState_;
	
	IBOutlet id IBchoicePackageStateEditButton_;
	
		// Requirements
		
	id requirementController_;
	
	IBOutlet id IBrequirementsArray_;
	
	IBOutlet id IBrequirementsAddButton_;
	
	IBOutlet id IBrequirementsEditButton_;
	
	IBOutlet id IBrequirementsRemoveButton_;
	
	// Data
	
	NSTabViewItem * tabViewItem_;
	
	ICInstallationTypeTreeNode * cachedTreeNode_;
	
	NSMutableArray * cachedTitleLocalizations_;
	
	NSMutableArray * cachedDescriptionLocalizations_;
	
	NSMutableArray * cachedRequirements_;
	
	BOOL editRequirementMode_;
}

- (IBAction) addTitleLocalization:(id) sender;

- (IBAction) removeTitleLocalization:(id) sender;

- (void) removeTitleLocalizationDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;


- (IBAction) addDescriptionLocalization:(id) sender;

- (IBAction) removeDescriptionLocalization:(id) sender;

- (void) removeDescriptionLocalizationDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;


- (IBAction) switchPackageVisibility:(id) sender;

- (IBAction) switchPackageState:(id) sender;

- (IBAction) editChoiceState:(id) sender;

- (IBAction) nothingTitle:(id) sender;

- (IBAction) nothingDescription:(id) sender;


- (void) updateRequirementTabLabel;

- (IBAction) addRequirement:(id) sender;

- (IBAction) editRequirement:(id) sender;

- (IBAction) removeRequirements:(id) sender;

- (void) removeRequirementsDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;

// Notificatoins

- (void) viewFrameDidChange:(NSNotification *) inNotification;

@end
