#import <Cocoa/Cocoa.h>

#import "ICProjectCreationStepController.h"

#import "ICProjectCreationAssistantEngine.h"



@interface ICProjectCreationAssistantController : NSObject
{
	IBOutlet id IBwindow_;
	
	IBOutlet id IBtopView_;
	
	IBOutlet id IBalwaysShowOnLaunchCheckBox_;
	
	IBOutlet id IBpreviousButton_;
	
    IBOutlet id IBnextButton_;

	ICProjectCreationStepController * currentViewController_;
	
	id currentView_;


	IBOutlet id startStepController_;
	
    IBOutlet id stopStepController_;

	// Data
	
	NSFileManager * fileManager_;
	
	ICProjectCreationAssistantEngine * assistantEngine_;
	
	NSMutableArray * projectsInformationArray_;
}

+ (id) sharedProjectCreationAssistantController;

- (void) createNewProject;

- (void) processStepController:(ICProjectCreationStepController *) inPaneController withEngine:(id) inEngine;

- (ICProjectCreationStepController *) stepControllerAtIndex:(int) inIndex;

-(IBAction) cancel:(id) sender;

-(IBAction) next:(id) sender;

-(IBAction) previous:(id) sender;

-(void) finishSetUp:(id) sender;

- (void) setEnableNextButton:(BOOL) aBool;


- (IBAction) switchAlwaysShowOnLaunch:(id) sender;


@end
