#import "ICProjectCreationStepController.h"

@implementation ICProjectCreationStepController

- (id) init
{
    self = [super init];
    
    if (self)
    {
        previousPaneIndex_=-1;
    }
    
    return self;
}

- (void) setMainController:(id) inMainController
{
    mainController_=inMainController;
}

- (void) loadPaneNib:(NSString *) inNibName withMainController: (id) inMainController
{
    if (IBview_==nil)
    {
        mainController_ = inMainController;
        
        previousPaneIndex_= -1;
        
        if ([NSBundle loadNibNamed:inNibName owner:self]==NO)
        {
            NSLog(@"A problem occured while loading the nib %@",inNibName);
            
            NSBeep();
            
            return;
        }
        
    }
}

- (void) initPaneWithEngine:(id) inEngine
{
    /*
      If you need to set some data to take into account some data obtained from the previous panes
      and saved in the process engine, then overload this method
    */
}

- (NSString *) nextPaneName
{
    return nil;
}

- (void) setPreviousPaneIndex:(int) inPreviousPaneIndex
{
    previousPaneIndex_=inPreviousPaneIndex;
}

- (int) previousPaneIndex
{
    return previousPaneIndex_;
}

- (BOOL) checkPaneValuesWithEngine:(id) inEngine
{
    /*
      Overload this method to be able to stop the navigation to the next pane
      if the values of the current pane are incorrect
    */
    
    return YES;
}

- (void) processWithEngine:(id) inEngine
{
    /*
      Overload this method to process the data provided by the user in this pane
      Don't forget to add the AKProcessEngine subclass header in the code
    */
}

@end
