/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICFileHierarchyController.h"

@interface ICProjectRequirementsController : ICFileHierarchyController
{
		// Requirements
		
	id requirementController_;
	
	IBOutlet id IBrequirementsSection_;
	
	IBOutlet id IBoptionsRootVolumeOnly_;
	
	IBOutlet id IBrequirementsScrollView_;
	
	IBOutlet id IBrequirementsArray_;
	
	IBOutlet id IBrequirementsAddButton_;
	
	IBOutlet id IBrequirementsEditButton_;
	
	IBOutlet id IBrequirementsRemoveButton_;
	
		// Scripts
		
	/*IBOutlet id IBpreInstallPath_;
	
	IBOutlet id IBpreInstallPathActionButton_;
	
	IBOutlet id IBpostInstallPath_;
	
	IBOutlet id IBpostInstallPathActionButton_;*/
	
		// Resources
		
	IBOutlet id IBresourcesSection_;
	
	// Data
	
	NSMutableArray * cachedRequirements_;
	
	NSMutableArray * cachedFormattedRequirements_;
	
	BOOL editRequirementMode_;
	
	CGFloat cachedRessourcesSectionInitialHeight_;
}

+ (ICProjectRequirementsController *) projectRequirementsController;

- (IBAction) switchRootVolumeOnly:(id) sender;

- (IBAction) addRequirement:(id) sender;

- (IBAction) editRequirement:(id) sender;

- (IBAction) removeRequirements:(id) sender;

- (void) updateCachedRequirements;

- (void) removeRequirementsDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;


/*- (IBAction) updatePreInstallPath:(id) sender;

- (IBAction) selectPreInstallPath:(id) sender;

- (void) selectPreInstallPathDidEnd:(NSOpenPanel *)sheet returnCode:(NSInteger)returnCode contextInfo:(void  *)contextInfo;

- (IBAction) revealPreInstallPathInFinder:(id) sender;

- (IBAction) updatePostInstallPath:(id) sender;

- (IBAction) selectPostInstallPath:(id) sender;

- (void) selectPostInstallPathDidEnd:(NSOpenPanel *)sheet returnCode:(NSInteger)returnCode contextInfo:(void  *)contextInfo;

- (IBAction) revealPostInstallPathInFinder:(id) sender;*/

// Notifications

- (void) viewFrameDidChange:(NSNotification *) inNotification;

@end
