/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICSegmentedController.h"

@interface ICProjectSettingsController_Package : ICSegmentedController
{
	IBOutlet id IBbuildSection_;
	
	IBOutlet id IBbuildName_;
	
	IBOutlet id IBbuildPath_;
	
	IBOutlet id IBbuildPathActionButton_;
	
	IBOutlet id IBreferenceFolderPopupButton_;
	
	IBOutlet id IBcertificateStamp_;
	
	IBOutlet id IBexclusionArray_;
	
	IBOutlet id IBexclusionAddButton_;
	
	IBOutlet id IBexclusionRemoveButton_;
	
	IBOutlet id IBexclusionOnlyPayloadCheckbox_;
	
	// Data
	
	NSWindow * certificateWindow_;
	
	NSMutableDictionary * cachedCertificateDictionary_; 
	
	NSMutableArray * cachedExcludedFilesArray_; 
	
	NSArray * cachedOptionsOrder_;
	
	CGFloat cachedBuildSectionInitialHeight_;
	
	NSUserDefaults * defaults_;
}

+ (ICProjectSettingsController_Package *) projectSettingsController;


- (void) delayedShowHideCertificate:(id) inObject;

- (IBAction) changeCertificate:(id) sender;

- (IBAction) viewCertificate:(id) sender;

- (IBAction) removeCertificate:(id) sender;

- (void) showCertificateChildWindow:(BOOL) inShow;


- (IBAction) setName:(id) sender;

- (IBAction) updateBuildPath:(id) sender;

- (IBAction) selectBuildPath:(id) sender;

- (void) buildOpenPanelDidEnd:(NSOpenPanel *)sheet returnCode:(NSInteger)returnCode contextInfo:(void  *)contextInfo;

- (IBAction) revealBuildPathInFinder:(id) sender;

- (IBAction) noAction:(id) sender;

- (IBAction) setReferenceFolder:(id) sender;

- (void) referenceFolderOpenPanelDidEnd:(NSOpenPanel *)sheet returnCode:(NSInteger)returnCode contextInfo:(void  *)contextInfo;

- (IBAction) resetReferenceFolder:(id) sender;

- (IBAction) addExcludedFile:(id) sender;

- (IBAction) removeExcludedFile:(id) sender;

- (void) removeExcludedFilesDidEnd:(NSWindow *) inWindow returnCode:(NSInteger) returnCode contextInfo:(void *) contextInfo;

- (IBAction) switchPayloadOnly:(id) sender;

// Notifications

- (void) viewFrameDidChange:(NSNotification *) inNotification;

@end
