/*
Copyright (c) 2004-2007, Stphane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICReferencedFileTextCell.h"

@implementation ICReferencedFileTextCell

- (void) setPathType:(int) inPathType
{
    pathType_=inPathType;
}

#pragma mark -

- (void)editWithFrame:(NSRect) inFrame inView:(NSView *) inControlView editor:(NSText *) inEditor delegate:(id) inDelegate event:(NSEvent *) inEvent
{
    NSRect textFrame, imageFrame;
    
    inFrame=NSInsetRect(inFrame,3,3);
    
    NSDivideRect (inFrame, &imageFrame, &textFrame, 3 + ICREFERENCEDFILETEXTCELL_ICON_WIDTH +ICREFERENCEDFILETEXTCELL_POPUP_WIDTH, NSMinXEdge);
    
    [super editWithFrame: textFrame
                  inView: inControlView
                  editor: inEditor
                delegate: inDelegate
                   event: inEvent];
}

- (void)selectWithFrame:(NSRect) inFrame inView:(NSView *) inControlView editor:(NSText *) inEditor delegate:(id) inDelegate start:(NSInteger) inStart length:(NSInteger) inLength
{
    NSRect textFrame, imageFrame;
    
    inFrame=NSInsetRect(inFrame,3,3);
    
    NSDivideRect (inFrame, &imageFrame, &textFrame, 3 + ICREFERENCEDFILETEXTCELL_ICON_WIDTH + ICREFERENCEDFILETEXTCELL_POPUP_WIDTH, NSMinXEdge);
    
    [super selectWithFrame: textFrame
                    inView: inControlView
                    editor: inEditor
                  delegate: inDelegate
                     start: inStart
                    length: inLength];
}

- (void)drawWithFrame:(NSRect) inFrame inView:(NSView *) inControlView
{
    NSRect	imageFrame;
    
    inFrame=NSInsetRect(inFrame,3,3);
    
    NSDivideRect(inFrame, &imageFrame, &inFrame, 3 + ICREFERENCEDFILETEXTCELL_ICON_WIDTH + ICREFERENCEDFILETEXTCELL_POPUP_WIDTH, NSMinXEdge);
    
    [super drawInteriorWithFrame:inFrame inView: inControlView];
}

- (NSSize) cellSize
{
    NSSize cellSize = [super cellSize];
    
    cellSize.width += ICREFERENCEDFILETEXTCELL_ICON_WIDTH + 3 + ICREFERENCEDFILETEXTCELL_POPUP_WIDTH;
    
    return cellSize;
}


@end
