/*
    Portions of this code are from a post on the Cocoa or OmniGroup mailing list
*/

#import "ICScrollView.h"
#import "JRSwizzle.h"

@interface NSClipView (TransparentMode)

- (void) drawOnlyIfNeeded:(NSRect) inRect;

@end
 
@implementation NSClipView (TransparentMode)

 - (BOOL)isOpaque
 { 
    return NO; 
 } 

- (void) drawOnlyIfNeeded:(NSRect) inRect 
 {
    if ([[self superview] isMemberOfClass:[ICScrollView class]]==NO)
    {
		[self drawOnlyIfNeeded:inRect];
    }
 }

 @end 
 
 @implementation ICScrollView

+ (void)load 
{ 
	NSError * tError;
	
	if ([NSClipView jr_swizzleMethod:@selector(drawRect:) withMethod:@selector(drawOnlyIfNeeded:) error:&tError]==NO)
	{
		// A COMPLETER
		
		//NSLog(@"");
	}
} 

- (void) awakeFromNib 
 { 
    [[self contentView] setCopiesOnScroll:NO]; 

    if ([[self documentView] isKindOfClass:[NSTextView class]])
    { 
        [[self documentView] setDrawsBackground:NO];
    }
}
 
 - (BOOL)isOpaque 
{ 
    return NO; 
}

- (void)drawRect:(NSRect)rect
{
}

@end
