/*
Copyright (c) 2007-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICWindow.h"

@implementation ICWindow

- (void) becomeKeyWindow
{
	NSEvent * tEvent;
	
	tEvent=[NSApp currentEvent];
	
	if (tEvent!=nil)
	{
		NSUInteger tModifierFlags;
		BOOL isDown=NO;
	
		tModifierFlags=[tEvent modifierFlags];

		isDown=((tModifierFlags & NSAlternateKeyMask) == NSAlternateKeyMask);
		
		if (isDown!=optionKeyDown_)
		{
			NSDictionary * tDictionary;
		
			optionKeyDown_=isDown;
			
			// Post Notification
			
			tDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithBool:optionKeyDown_],ICWINDOW_OPTIONKEY_STATE,nil];
			
			[[NSNotificationCenter defaultCenter] postNotificationName:ICWINDOW_NOTIFICATION_OPTIONKEY_DID_CHANGE object:self userInfo:tDictionary];
		}
	}
	
	[super becomeKeyWindow];
}

- (void) resignKeyWindow
{
	if (optionKeyDown_==YES)
	{
		NSDictionary * tDictionary;
	
		optionKeyDown_=NO;
		
		// Post Notification
		
		tDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithBool:NO],ICWINDOW_OPTIONKEY_STATE,nil];
		
		[[NSNotificationCenter defaultCenter] postNotificationName:ICWINDOW_NOTIFICATION_OPTIONKEY_DID_CHANGE object:self userInfo:tDictionary];
	}
	
	[super resignKeyWindow];
}

- (void) flagsChanged:(NSEvent *) inEvent
{
	if (inEvent!=nil)
	{
		NSUInteger tModifierFlags;
		BOOL isDown=NO;
		
		tModifierFlags=[inEvent modifierFlags];
	
		isDown=((tModifierFlags & NSAlternateKeyMask) == NSAlternateKeyMask);
		
		if (isDown!=optionKeyDown_)
		{
			NSDictionary * tDictionary;
		
			optionKeyDown_=isDown;
			
			// Post Notification
			
			tDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithBool:optionKeyDown_],ICWINDOW_OPTIONKEY_STATE,nil];
			
			[[NSNotificationCenter defaultCenter] postNotificationName:ICWINDOW_NOTIFICATION_OPTIONKEY_DID_CHANGE object:self userInfo:tDictionary];
		}
	}
}

@end
