#import "ICIntegerFormatter.h"

@implementation ICIntegerFormatter

- (NSString *) stringForObjectValue:(id) inObject
{
    if ([inObject isKindOfClass:[NSString class]]==NO)
	{
		return inObject;
    }
    
    return inObject;
}

- (BOOL) getObjectValue:(id *) outObject forString:(NSString *) inString errorDescription:(NSString **) outError
{
    *outObject=[[inString copy] autorelease];
     
    return YES;
}

#pragma mark -

- (BOOL) isPartialStringValid:(NSString *) inPartialString newEditingString:(NSString **) outNewString errorDescription:(NSString **) outError
{
    if (inPartialString!=nil)
	{
		unsigned int tLength;
		
		tLength=[inPartialString length];
		
		if (tLength>0)
		{
			unsigned int tIndex;
			unichar tChar;
		
			if (tLength>5)
			{
				*outNewString=nil;
					
				*outError=[NSString stringWithString:@"NSBeep"];
					
				return NO;
			}
		
			tChar=[inPartialString characterAtIndex:0];
		
			if ((tChar<'0' || tChar>'9') && tChar!='-')
			{
				*outNewString=nil;
					
				*outError=[NSString stringWithString:@"NSBeep"];
					
				return NO;
			}
			
			for(tIndex=1;tIndex<tLength;tIndex++)
			{
				tChar=[inPartialString characterAtIndex:tIndex];
				
				if (tChar<'0' || tChar>'9')
				{
					*outNewString=nil;
					
					*outError=[NSString stringWithString:@"NSBeep"];
					
					return NO;
				}
			}
		}
	}
	
	return YES;
}

@end
