#import "ICRequirementConverter_CPU_Controller.h"

#import "ICRequirement_CPU+Constants.h"
											
@implementation ICRequirementConverter_CPU_Controller

- (int) requirementTypeWithParameters:(NSDictionary *) inParameters
{
	return IC_REQUIREMENT_CHECK_TYPE_INSTALLATION; 
}

- (NSString *) invocationWithFormat:(NSString *) inFormat parameters:(NSDictionary *) inParameters index:(int) inIndex error:(NSDictionary **) outErrorDictionary
{
	NSString * tInvocation=nil;
	NSNumber * tNumber;
	
	tNumber=[inParameters objectForKey:IC_REQUIREMENT_CPU_MINIMUM_CPU_CORES_COUNT];
	
	if (tNumber!=nil)
	{
		NSInteger tMinimumCoresCount;
		
		tMinimumCoresCount=[tNumber integerValue];
		
		if (tMinimumCoresCount>=0)
		{
			tNumber=[inParameters objectForKey:IC_REQUIREMENT_CPU_ARCHITECTURE_FAMILY];
	
			if (tNumber!=nil)
			{
				NSInteger tArchitectureFamily;
				
				tArchitectureFamily=[tNumber integerValue];
				
				if (tArchitectureFamily>=CPU_ARCHITECTURE_ANY && tArchitectureFamily<=CPU_ARCHITECTURE_INTEL)
				{
					NSString * tFamilyString;
					NSString * tPowerPCTypeString=@"IC_CPU_ARCHITECTURE_TYPE_ANY";
					NSString * tIntelTypeString=@"IC_CPU_ARCHITECTURE_TYPE_ANY";
					
					if (tArchitectureFamily==CPU_ARCHITECTURE_POWERPC)
					{
						tFamilyString=@"IC_CPU_ARCHITECTURE_POWERPC";
					}
					else if (tArchitectureFamily==CPU_ARCHITECTURE_INTEL)
					{
						tFamilyString=@"IC_CPU_ARCHITECTURE_INTEL";
					}
					else
					{
						tFamilyString=@"IC_CPU_ARCHITECTURE_ANY";
					}
					
					if (tArchitectureFamily==CPU_ARCHITECTURE_POWERPC || tArchitectureFamily==CPU_ARCHITECTURE_TYPE_ANY)
					{
						tNumber=[inParameters objectForKey:IC_REQUIREMENT_CPU_POWERPC_ARCHITECTURE_TYPE];
	
						if (tNumber!=nil)
						{
							NSInteger tPowerPCType;
							
							tPowerPCType=[tNumber integerValue];
							
							if (tPowerPCType==CPU_ARCHITECTURE_TYPE_32)
							{
								tPowerPCTypeString=@"IC_CPU_ARCHITECTURE_TYPE_32";
							}
							else if (tPowerPCType==CPU_ARCHITECTURE_TYPE_64)
							{
								tPowerPCTypeString=@"IC_CPU_ARCHITECTURE_TYPE_64";
							}
						}
						else
						{
							*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																						   IC_REQUIREMENT_CPU_POWERPC_ARCHITECTURE_TYPE,ICRequirementConverterErrorParameter,
																						   nil];
						
							return nil;
						}
					}
					
					if (tArchitectureFamily==CPU_ARCHITECTURE_INTEL || tArchitectureFamily==CPU_ARCHITECTURE_TYPE_ANY)
					{
						tNumber=[inParameters objectForKey:IC_REQUIREMENT_CPU_INTEL_ARCHITECTURE_TYPE];
	
						if (tNumber!=nil)
						{
							NSInteger tIntelType;
							
							tIntelType=[tNumber integerValue];
							
							if (tIntelType==CPU_ARCHITECTURE_TYPE_32)
							{
								tIntelTypeString=@"IC_CPU_ARCHITECTURE_TYPE_32";
							}
							else if (tIntelType==CPU_ARCHITECTURE_TYPE_64)
							{
								tIntelTypeString=@"IC_CPU_ARCHITECTURE_TYPE_64";
							}
						}
						else
						{
							*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																						   IC_REQUIREMENT_CPU_INTEL_ARCHITECTURE_TYPE,ICRequirementConverterErrorParameter,
																						   nil];
						
							return nil;
						}
					}
					
					tNumber=[inParameters objectForKey:IC_REQUIREMENT_CPU_MINIMUM_FREQUENCY];
					
					if (tNumber!=nil)
					{
						unsigned long long tMinimumFrequency;
						
						tMinimumFrequency=[tNumber unsignedLongLongValue];
						
						tInvocation=[NSString stringWithFormat:inFormat,tMinimumCoresCount,tFamilyString,tPowerPCTypeString,tIntelTypeString,tMinimumFrequency];
					}
					else
					{
						*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																					   IC_REQUIREMENT_CPU_MINIMUM_FREQUENCY,ICRequirementConverterErrorParameter,
																					   nil];
					}
					
				}
				else
				{
					*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																				   IC_REQUIREMENT_CPU_ARCHITECTURE_FAMILY,ICRequirementConverterErrorParameter,
																				   nil];
				}
			}
			else
			{
				*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																			   IC_REQUIREMENT_CPU_ARCHITECTURE_FAMILY,ICRequirementConverterErrorParameter,
																			   nil];
			}	
			
			
			
			
			
		}
		else
		{
			*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																		   IC_REQUIREMENT_CPU_MINIMUM_CPU_CORES_COUNT,ICRequirementConverterErrorParameter,
																		   nil];
		}
	}
	else
	{
		*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																	   IC_REQUIREMENT_CPU_MINIMUM_CPU_CORES_COUNT,ICRequirementConverterErrorParameter,
																	   nil];
	}
	
	return tInvocation;
}

@end
