#import "ICRequirementConverter_DiskSpace_Controller.h"

#import "ICRequirement_DiskSpace+Constants.h"

#define DISKSPACE_CONVERSION_COUNT	4

static unsigned long long sDiskSpaceConversionTable[DISKSPACE_CONVERSION_COUNT]={
																			  1024ULL,		/* MB */
																		   1048576ULL,		/* GB */
																		1073741824ULL,		/* TB */
																	 1099511627776ULL,		/* PB */
																	};

@implementation ICRequirementConverter_DiskSpace_Controller

- (int) requirementTypeWithParameters:(NSDictionary *) inParameters
{
	return IC_REQUIREMENT_CHECK_TYPE_TARGET;
}

- (NSString *) invocationWithFormat:(NSString *) inFormat parameters:(NSDictionary *) inParameters index:(int) inIndex error:(NSDictionary **) outErrorDictionary
{
	NSString * tInvocation=nil;
	/*NSNumber * tDiskTypeNumber;
	
	tDiskTypeNumber=[inParameters objectForKey:IC_REQUIREMENT_DISKSPACE_DISK_TYPE];
	
	if (tDiskTypeNumber==nil)
	{
		*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																	   IC_REQUIREMENT_DISKSPACE_DISK_TYPE,ICRequirementConverterErrorParameter,
																	   nil];
	}
	else
	{
		int tDiskType;
		
		tDiskType=[tDiskTypeNumber intValue];
		
		if (tDiskType==DISKSPACE_DISK_STARTUP || tDiskType==DISKSPACE_DISK_DESTINATION)
		{*/
			NSNumber * tMinimumSizeUnitNumber;
			/*NSString * tDiskTypeConstantString;
			
			if (tDiskType==DISKSPACE_DISK_STARTUP)
			{
				tDiskTypeConstantString=@"IC_DiskType_StartupDisk";
			}
			else if (tDiskType==DISKSPACE_DISK_DESTINATION)
			{
				tDiskTypeConstantString=@"IC_DiskType_Destination";
			}*/
			
			tMinimumSizeUnitNumber=[inParameters objectForKey:IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_UNIT];
			
			if (tMinimumSizeUnitNumber==nil)
			{
				*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																			   IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_UNIT,ICRequirementConverterErrorParameter,
																			   nil];
			}
			else
			{
				NSInteger tUnit;
				
				tUnit=[tMinimumSizeUnitNumber integerValue];
				
				if (tUnit>=DISKSPACE_MINIMUM_SIZE_UNIT_MB && tUnit<=DISKSPACE_MINIMUM_SIZE_UNIT_PB)
				{
					NSNumber * tMinimumSizeValueNumber;
					
					tMinimumSizeValueNumber=[inParameters objectForKey:IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_VALUE];
			
					if (tMinimumSizeValueNumber==nil)
					{
						*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																					   IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_VALUE,ICRequirementConverterErrorParameter,
																					   nil];
					}
					else
					{
						NSInteger tValue;
						
						tValue=[tMinimumSizeValueNumber integerValue];
						
						if (tValue>=0)
						{
							unsigned long long tMinimumValueKB;
							
							tMinimumValueKB=tValue*sDiskSpaceConversionTable[tUnit]*1024;	// x 1024 because of a bug in the API.
							
							tInvocation=[NSString stringWithFormat:inFormat,/*tDiskTypeConstantString,*/tMinimumValueKB];
						}
						else
						{
							*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																						   IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_VALUE,ICRequirementConverterErrorParameter,
																						   nil];
						}
					}
				}
				else
				{
					*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																				   IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_UNIT,ICRequirementConverterErrorParameter,
																				   nil];
				}
			}
		/*}
		else
		{
			*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																		   IC_REQUIREMENT_DISKSPACE_DISK_TYPE,ICRequirementConverterErrorParameter,
																		   nil];
		}
	}*/
	
	return tInvocation;
}

@end
