#import "ICDiskSpaceFormatter.h"

@implementation ICDiskSpaceFormatter

- (NSString *) stringForObjectValue:(id) inObject
{
    if ([inObject isKindOfClass:[NSString class]]==NO)
	{
		return inObject;
    }
    
    return inObject;
}

- (BOOL) getObjectValue:(id *) outObject forString:(NSString *) inString errorDescription:(NSString **) outError
{
    *outObject=[[inString copy] autorelease];
     
    return YES;
}

#pragma mark -

- (BOOL) isPartialStringValid:(NSString *) inPartialString newEditingString:(NSString **) outNewString errorDescription:(NSString **) outError
{
    if (inPartialString!=nil)
	{
		unsigned int tLength;
		unsigned int tIndex;
		
		tLength=[inPartialString length];
		
		if (tLength>5)
		{
			*outNewString=nil;
				
			*outError=[NSString stringWithString:@"NSBeep"];
				
			return NO;
		}
		
		for(tIndex=0;tIndex<tLength;tIndex++)
		{
			unichar tChar;
			
			tChar=[inPartialString characterAtIndex:tIndex];
			
			if (tChar<'0' || tChar>'9')
			{
				*outNewString=nil;
				
				*outError=[NSString stringWithString:@"NSBeep"];
				
				return NO;
			}
		}
	}
	
	return YES;
}

@end
