#import "ICRequirementUI_DiskSpace_Controller.h"

#import "ICDiskSpaceFormatter.h"

#import "ICRequirement_DiskSpace+Constants.h"

@implementation ICRequirementUI_DiskSpace_Controller

- (void) awakeFromNib
{
	ICDiskSpaceFormatter * tFormatter;
	
	tFormatter=[ICDiskSpaceFormatter new];
	
	if (tFormatter!=nil)
	{
		[IBminimumValue_ setFormatter:tFormatter];
		
		[tFormatter release];
	}
}

- (void) initializeWithDictionary:(NSMutableDictionary *) inDictionary forDocument:(id) inDocument
{
	[super initializeWithDictionary:inDictionary forDocument:inDocument];
	
	dictionary_=[inDictionary mutableDeepCopy];
	
	if (dictionary_!=nil)
	{
		NSNumber * tNumber;
		int tTag;
		NSString * tStringValue;
		
		// Disk Type
		
		/*tNumber=[dictionary_ objectForKey:IC_REQUIREMENT_DISKSPACE_DISK_TYPE];
		
		if (tNumber==nil)
		{
			tTag=DISKSPACE_DISK_DESTINATION;
		}
		else
		{
			tTag=[tNumber intValue];
		}
		
		[IBdiskType_ selectItemWithTag:tTag];*/
		
		// Minimum Size Value
		
		tNumber=[dictionary_ objectForKey:IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_VALUE];
		
		if (tNumber==nil)
		{
			tStringValue=@"100";
		}
		else
		{
			tStringValue=[tNumber stringValue];
		}
		
		[IBminimumValue_ setStringValue:tStringValue];
		
		// Minimum Size Unit
		
		tNumber=[dictionary_ objectForKey:IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_UNIT];
		
		if (tNumber==nil)
		{
			tTag=DISKSPACE_MINIMUM_SIZE_UNIT_MB;
		}
		else
		{
			tTag=[tNumber intValue];
		}
		
		[IBunit_ selectItemWithTag:tTag];
	}
}

#pragma mark -

- (NSMutableDictionary *) defaultDictionary
{
	return [NSMutableDictionary dictionaryWithObjectsAndKeys:/*[NSNumber numberWithInt:DISKSPACE_DISK_DESTINATION],IC_REQUIREMENT_DISKSPACE_DISK_TYPE,*/
															 [NSNumber numberWithInt:100],IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_VALUE,
															 [NSNumber numberWithInt:DISKSPACE_MINIMUM_SIZE_UNIT_MB],IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_UNIT,
															 nil];
}

- (int) requirementType
{
	return IC_REQUIREMENT_CHECK_TYPE_TARGET;
}

#pragma mark -

- (NSView *) previousKeyView
{
	return IBminimumValue_;
}

- (void) setNextKeyView:(NSView *) inView
{
	[IBminimumValue_ setNextKeyView:inView];
}

/*- (IBAction) switchDiskType:(id) sender
{
	int tTag;
	NSNumber * tNumber;
	
	tTag=[[sender selectedItem] tag];
	
	tNumber=[NSNumber numberWithInt:tTag];
	
	if (tNumber!=nil)
	{
		[dictionary_ setObject:tNumber forKey:IC_REQUIREMENT_DISKSPACE_DISK_TYPE];
	}
}*/

- (void) control:(NSControl *) inControl didFailToValidatePartialString:(NSString *) inPartialString errorDescription:(NSString *) inError
{
	if (inError!=nil && [inError isEqualToString:@"NSBeep"]==YES)
	{
		NSBeep();
	}
}


- (IBAction) setMinimumValue:(id) sender
{
	NSString * tStringValue;
	NSNumber * tNumber;
	
	tStringValue=[IBminimumValue_ stringValue];
	
	tNumber=[NSNumber numberWithInt:[tStringValue intValue]];
	
	if (tNumber!=nil)
	{
		[dictionary_ setObject:tNumber forKey:IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_VALUE];
	}
}

- (IBAction) switchUnit:(id) sender
{
	int tTag;
	NSNumber * tNumber;
	
	tTag=[[sender selectedItem] tag];
	
	tNumber=[NSNumber numberWithInt:tTag];
	
	if (tNumber!=nil)
	{
		[dictionary_ setObject:tNumber forKey:IC_REQUIREMENT_DISKSPACE_MINIMUM_SIZE_UNIT];
	}
}

@end
