#import "ICRequirementConverter_Files_Controller.h"

#import "ICRequirement_Files+Constants.h"


@implementation ICRequirementConverter_Files_Controller

- (int) requirementTypeWithParameters:(NSDictionary *) inParameters
{
	if (inParameters!=nil)
	{
		NSNumber * tNumber;
	
		tNumber=[inParameters objectForKey:IC_REQUIREMENT_FILES_DISK_TYPE];
		
		if (tNumber!=nil)
		{
			NSInteger tDiskType;
			
			tDiskType=[tNumber integerValue];
			
			if (tDiskType==IC_FILES_DISK_TYPE_STARTUP_DISK)
			{
				return IC_REQUIREMENT_CHECK_TYPE_INSTALLATION;
			}
			else if (tDiskType==IC_FILES_DISK_TYPE_DESTINATION)
			{
				return IC_REQUIREMENT_CHECK_TYPE_TARGET;
			}
		}
	}
	
	return IC_REQUIREMENT_CHECK_TYPE_UNDEFINED;
}

- (NSString *) variablesWithIndex:(int) inIndex tabulationDepth:(NSString *) inTabulationDepth parameters:(NSDictionary *) inParameters error:(NSDictionary **) outErrorDictionary;
{
	NSArray * tArray;
	
	tArray=[inParameters objectForKey:IC_REQUIREMENT_FILES_LIST];
	
	if (tArray!=nil)
	{
		NSUInteger tCount;
			
		tCount=[tArray count];
			
		if (tCount>0)
		{
			NSMutableString * tMutableString;
		
			tMutableString=[NSMutableString stringWithFormat:@"%@var tFilesToCheck%d=new Array(",inTabulationDepth,inIndex];
			
			if (tMutableString!=nil)
			{
				NSUInteger i;
				
				for(i=0;i<tCount;i++)
				{
					NSString * tPath;
					
					tPath=[tArray objectAtIndex:i];
					
					// Escape the string (" > < &")
					
					tPath=(NSString *) CFXMLCreateStringByEscapingEntities(kCFAllocatorDefault,(CFStringRef) tPath,NULL);
							
					if (tPath!=nil)
					{
						[tMutableString appendFormat:@"\'%@\'",tPath];
					
						[tPath release];
					}
					else
					{
						// A COMPLETER
					}
					
					if (i!=(tCount-1))
					{
						[tMutableString appendFormat:@",\n%@                             ",inTabulationDepth];
					}
				}
				
				[tMutableString appendString:@");\n\n"];
				
				return tMutableString;
			}
		}
		else
		{
			return @"";
		}
					
	}
	else
	{
		*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																	   IC_REQUIREMENT_FILES_DISK_TYPE,ICRequirementConverterErrorParameter,
																	   nil];
	}
	
	return nil;
}

- (NSString *) invocationWithFormat:(NSString *) inFormat parameters:(NSDictionary *) inParameters index:(int) inIndex error:(NSDictionary **) outErrorDictionary
{
	NSString * tInvocation=nil;
	NSNumber * tNumber;
	
	tNumber=[inParameters objectForKey:IC_REQUIREMENT_FILES_DISK_TYPE];
	
	if (tNumber!=nil)
	{
		NSInteger tDiskType;
		
		tDiskType=[tNumber integerValue];
		
		if (tDiskType>=IC_FILES_DISK_TYPE_DESTINATION && tDiskType<=IC_FILES_DISK_TYPE_STARTUP_DISK)
		{
			NSString * tDiskTypeString=@"IC_DISK_TYPE_DESTINATION";
			
			if (tDiskType==IC_FILES_DISK_TYPE_STARTUP_DISK)
			{
				tDiskTypeString=@"IC_DISK_TYPE_STARTUP_DISK";
			}
			
			tNumber=[inParameters objectForKey:IC_REQUIREMENT_FILES_SELECTOR];
			
			if (tNumber!=nil)
			{
				NSInteger tSelector;
				
				tSelector=[tNumber integerValue];
				
				if (tSelector>=IC_REQUIREMENT_FILES_SELECTOR_ANY && tSelector<=IC_REQUIREMENT_FILES_SELECTOR_ALL)
				{
					NSString * tSelectorString=@"IC_SELECTOR_ANY";
					
					if (tSelector==IC_REQUIREMENT_FILES_SELECTOR_ALL)
					{
						tSelectorString=@"IC_SELECTOR_ALL";
					}
					
					tNumber=[inParameters objectForKey:IC_REQUIREMENT_FILES_CONDITION];
			
					if (tNumber!=nil)
					{
						NSInteger tCondition;
						
						tCondition=[tNumber integerValue];
						
						if (tCondition>=IC_REQUIREMENT_FILES_CONDITION_EXIST && tCondition<=IC_REQUIREMENT_FILES_CONDITION_DOES_NOT_EXIST)
						{
							NSString * tConditionString=@"IC_CONDITION_EXIST";
							
							if (tCondition==IC_REQUIREMENT_FILES_CONDITION_DOES_NOT_EXIST)
							{
								tConditionString=@"IC_CONDITION_DOES_NOT_EXIST";
							}
							
							tInvocation=[NSString stringWithFormat:inFormat,tSelectorString,tConditionString,tDiskTypeString,[NSString stringWithFormat:@"tFilesToCheck%d",inIndex]];
						}
						else
						{
							*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																						   IC_REQUIREMENT_FILES_CONDITION,ICRequirementConverterErrorParameter,
																						   nil];
						}
					}
					else
					{
						*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																					   IC_REQUIREMENT_FILES_CONDITION,ICRequirementConverterErrorParameter,
																					   nil];
					}
				}
				else
				{
					*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																				   IC_REQUIREMENT_FILES_SELECTOR,ICRequirementConverterErrorParameter,
																				   nil];
				}
			}
			else
			{
				*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																			   IC_REQUIREMENT_FILES_SELECTOR,ICRequirementConverterErrorParameter,
																			   nil];
			}
		}
		else
		{
			*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																		   IC_REQUIREMENT_FILES_DISK_TYPE,ICRequirementConverterErrorParameter,
																		   nil];
		}
	}
	else
	{
		*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																	   IC_REQUIREMENT_FILES_DISK_TYPE,ICRequirementConverterErrorParameter,
																	   nil];
	}
	
	return tInvocation;
}

@end
