#import "ICRequirementConverter_RAM_Controller.h"

#import "ICRequirement_RAM+Constants.h"

#define RAM_CONVERSION_COUNT	10

static unsigned long long sRAMConversionTable[RAM_CONVERSION_COUNT]={
																		536870912ULL,		/* 512 MB */
																	   1073741824ULL,		/* 1 GB */
																	   1610612736ULL,		/* 1.5 GB */
																	   2147483648ULL,		/* 2 GB */
																	   3221225472ULL,		/* 3 GB */
																	   4294967296ULL,		/* 4 GB */
																	   8589934592ULL,		/* 8 GB */
																	  17179869184ULL,		/* 16 GB */
																	  34359738368ULL,		/* 32 GB */
																	  68719476736ULL		/* 64 GB */
																	};
											
											
											
@implementation ICRequirementConverter_RAM_Controller

- (int) requirementTypeWithParameters:(NSDictionary *) inParameters
{
	return IC_REQUIREMENT_CHECK_TYPE_INSTALLATION; 
}

- (NSString *) invocationWithFormat:(NSString *) inFormat parameters:(NSDictionary *) inParameters index:(int) inIndex error:(NSDictionary **) outErrorDictionary
{
	NSString * tInvocation=nil;
	NSNumber * tNumber;
	
	tNumber=[inParameters objectForKey:IC_REQUIREMENT_RAM_MINIMUM_SIZE_INDEX];
	
	if (tNumber!=nil)
	{
		int tIndex;
		
		tIndex=[tNumber intValue];
		
		if (tIndex>=0 && tIndex<RAM_CONVERSION_COUNT)
		{
			tInvocation=[NSString stringWithFormat:inFormat,sRAMConversionTable[tIndex]];
		}
		else
		{
			*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorInvalidParameter],ICRequirementConverterErrorCode,
																		   IC_REQUIREMENT_RAM_MINIMUM_SIZE_INDEX,ICRequirementConverterErrorParameter,
																		   nil];
		}
	}
	else
	{
		*outErrorDictionary=[NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:ICRequirementConverterErrorMissingParameter],ICRequirementConverterErrorCode,
																	   IC_REQUIREMENT_RAM_MINIMUM_SIZE_INDEX,ICRequirementConverterErrorParameter,
																	   nil];
	}
	
	return tInvocation;
}

@end
