#import "ICRequirementUI_RAM_Controller.h"

#import "ICRequirement_RAM+Constants.h"

@implementation ICRequirementUI_RAM_Controller

- (void) initializeWithDictionary:(NSMutableDictionary *) inDictionary forDocument:(id) inDocument
{
	[super initializeWithDictionary:inDictionary forDocument:inDocument];

	dictionary_=[inDictionary mutableDeepCopy];
	
	if (dictionary_!=nil)
	{
		NSNumber * tNumber;
		NSInteger tIndex;
		
		// Mimimum Size Index
		
		tNumber=[dictionary_ objectForKey:IC_REQUIREMENT_RAM_MINIMUM_SIZE_INDEX];
		
		if (tNumber==nil)
		{
			tIndex=RAM_MINIMUM_SIZE_512_MB;
		}
		else
		{
			tIndex=[tNumber intValue];
		}
		
		[IBminimumRAMStepper_ setIntValue:tIndex];
	}
}

#pragma mark -

- (NSMutableDictionary *) defaultDictionary
{
	return [NSMutableDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInteger:RAM_MINIMUM_SIZE_512_MB],IC_REQUIREMENT_RAM_MINIMUM_SIZE_INDEX,
															 nil];
}

- (int) requirementType
{
	return IC_REQUIREMENT_CHECK_TYPE_INSTALLATION;
}

#pragma mark -

- (IBAction) setMinimumRAM:(id) sender
{
	NSInteger tIndex;
	NSNumber * tNumber;
	
	tIndex=[sender intValue];
	
	tNumber=[NSNumber numberWithInteger:tIndex];
	
	if (tNumber!=nil)
	{
		[dictionary_  setObject:tNumber forKey:IC_REQUIREMENT_RAM_MINIMUM_SIZE_INDEX];
	}
	else
	{
		NSLog(@"[ICRequirementUI_RAM_Controller setMinimumRAM:]");
	}
}

@end
