/*
Copyright (c) 2004-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import <Foundation/Foundation.h>

#import "ICDocumentFormat+MinimumConstants.h"

#import "ICDocumentFormat+SharedGlobalData.h"

enum
{
    ICDOCUMENT_FILE_BASE_NODE_INVISIBLE=-1,
	ICDOCUMENT_FILE_ROOT_NODE=0,
	ICDOCUMENT_FILE_BASE_NODE,
	ICDOCUMENT_FILE_NEWFOLDER_NODE,
	ICDOCUMENT_FILE_REALFILE_NODE,
};

enum
{
	ICOPERATOR_AND,
	ICOPERATOR_OR
};

enum
{
	ICCOMPARATOR_IS,
	ICCOMPARATOR_IS_NOT
};

enum
{
	ICSTATE_ENABLED,
	ICSTATE_SELECTED
};

#define ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHY_COUNT	3

enum
{
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHY_INSTALLER_TAG=0,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHY_SOFTWAREUPDATE_TAG,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHY_INVISIBLE_TAG
};

// Common Keywords

extern NSString * const ICDOCUMENT_LOCALIZATIONS;

extern NSString * const ICDOCUMENT_LANGUAGE;

extern NSString * const ICDOCUMENT_VALUE;

extern NSString * const ICDOCUMENT_SECONDARY_VALUE;

// Requirements

extern NSString * const ICDOCUMENT_REQUIREMENT_STATE;

extern NSString * const ICDOCUMENT_REQUIREMENT_NAME;

extern NSString * const ICDOCUMENT_REQUIREMENT_IDENTIFIER;

extern NSString * const ICDOCUMENT_REQUIREMENT_VERSION;

extern NSString * const ICDOCUMENT_REQUIREMENT_DICTIONARY;

enum
{
	ICDOCUMENT_REQUIREMENT_FAILURE_BEHAVIOR_CHOICE_UNSELECT_AND_HIDE=0,
	ICDOCUMENT_REQUIREMENT_FAILURE_BEHAVIOR_CHOICE_UNSELECT_AND_DISABLE,
	ICDOCUMENT_REQUIREMENT_FAILURE_BEHAVIOR_WARN,
	ICDOCUMENT_REQUIREMENT_FAILURE_BEHAVIOR_FAIL
};

extern NSString * const ICDOCUMENT_REQUIREMENT_FAILURE_BEHAVIOR;

extern NSString * const ICDOCUMENT_REQUIREMENT_MESSAGE;

// Keywords

extern NSString * const ICDOCUMENT_VERSION;

#define ICDOCUMENT_VERSION_NEXT_INCOMPATIBLE_VERSION	10

enum
{
	ICDOCUMENT_TYPE_DISTRIBUTION,
	ICDOCUMENT_TYPE_PACKAGE
};

extern NSString * const ICDOCUMENT_TYPE;

// Project

extern NSString * const ICDOCUMENT_PROJECT;

// Project - Settings

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_NAME;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_BUILD_PATH;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_REFERENCE_FOLDER_PATH;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_CERTIFICATE;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_CERTIFICATE_NAME;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_CERTIFICATE_KEYCHAIN_PATH;

enum
{
	ICDOCUMENT_PROJECT_SETTINGS_BUILD_FORMAT_FLAT=0,
	ICDOCUMENT_PROJECT_SETTINGS_BUILD_FORMAT_BUNDLE
};

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_BUILD_FORMAT;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_BUILD_HIERARCHY;	// Not used

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERNS_ARRAY;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERN_ITEM_REGULAR_EXPRESSION;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERN_ITEM_STRING;

enum
{
	ICFILE_TYPE_FILE=0,
	ICFILE_TYPE_FOLDER,
	ICFILE_TYPE_FILE_OR_FOLDER,
};

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERN_ITEM_FILE_TYPE;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERNS_PROTECTED;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_SEPARATOR;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERNS_STATE;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERNS_PROXY_NAME;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PATTERNS_PROXY_TOOLTIP;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_EXCLUDED_FILES_PAYLOAD_ONLY;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_ADVANCED_OPTIONS;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_ADVANCED_OPTIONS_MIN_SPEC_VERSION;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_ADVANCED_OPTIONS_VERIFIED_SPEC_VERSION;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_ADVANCED_OPTIONS_MAX_SPEC_VERSION;

extern NSString * const ICDOCUMENT_PROJECT_SETTINGS_ADVANCED_OPTIONS_UI;

// Project - Presentation

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION;


extern NSString * const ICDOCUMENT_PROJECT_INSTALLATION_STEPS;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_TITLE;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_BACKGROUND;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_BACKGROUND_CUSTOM;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_BACKGROUND_PATH;

enum
{
	ICALIGNMENT_CENTER=0,
	ICALIGNMENT_TOP,
	ICALIGNMENT_TOP_LEFT,
	ICALIGNMENT_TOP_RIGHT,
	ICALIGNMENT_LEFT,
	ICALIGNMENT_BOTTOM,
	ICALIGNMENT_BOTTOM_LEFT,
	ICALIGNMENT_BOTTOM_RIGHT,
	ICALIGNMENT_RIGHT
};

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_BACKGROUND_ALIGNMENT;

enum
{
	ICSCALING_PROPORTIONALLY=0,
	ICSCALING_TO_FIT,
	ICSCALING_NONE,
};

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_BACKGROUND_SCALING;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INTRODUCTION;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_README;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_LICENSE;

enum
{
	ICLICENSE_MODE_CUSTOM=0,
	ICLICENSE_MODE_TEMPLATE
};

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_LICENSE_MODE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_LICENSE_TEMPLATE_NAME;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_LICENSE_TEMPLATE_KEYWORDS;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE;

enum
{
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_MODE_ALLOW=0,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_MODE_NEVER,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_MODE_ALWAYS
};

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_MODE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHY_INSTALLER;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHY_SOFTWAREUPDATE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHY_INVISIBLE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHIES;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHIES_LIST;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_HIERARCHIES_REMOVED;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_UUID;

enum
{
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_TYPE_PACKAGE=0,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_TYPE_GROUP
};

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_TYPE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_PACKAGE_UUID;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_GROUP_CHILDREN;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_TITLE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_DESCRIPTION;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_TOOLTIP;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS;

enum
{
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_REQUIRED=0,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_SELECTED,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_UNSELECTED,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENT,
	
	// GROUP (NOT HIDDEN)
	
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_ENABLED_ALWAYS,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_ENABLED_NEVER,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_ENABLED_DEPENDENT
};

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENCY;

enum
{
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENCY_ENABLED_STATE_ALWAYS=0,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENCY_ENABLED_STATE_NEVER,
	ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENCY_ENABLED_STATE_DEPENDENT
};

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENCY_ENABLED_STATE_MODE;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENCY_ENABLED_DICTIONARY;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_STATE_DEPENDENCY_SELECTED_DICTIONARY;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_HIDDEN;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_OPTIONS_HIDE_CHILDREN;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_LIST_ITEM_REQUIREMENTS;



extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_CHOICE_TREE_BRANCH_TOP;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_CHOICE_TREE_BRANCH_BOTTOM;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_CHOICE_TREE_BRANCH_OPERATOR;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_CHOICE_TREE_LEAF_ITEM_UUID;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_CHOICE_TREE_LEAF_ITEM_COMPARATOR;

extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_INSTALLATION_TYPE_CHOICE_TREE_LEAF_ITEM_STATE_OBJECT;


extern NSString * const ICDOCUMENT_PROJECT_PRESENTATION_SUMMARY;


// Project - Requirements

extern NSString * const ICDOCUMENT_PROJECT_REQUIREMENTS;

extern NSString * const ICDOCUMENT_PROJECT_REQUIREMENTS_ROOT_VOLUME_ONLY;

extern NSString * const ICDOCUMENT_PROJECT_REQUIREMENTS_LIST;

extern NSString * const ICDOCUMENT_PROJECT_REQUIREMENTS_PREINSTALL_PATH;

extern NSString * const ICDOCUMENT_PROJECT_REQUIREMENTS_POSTINSTALL_PATH;

extern NSString * const ICDOCUMENT_PROJECT_REQUIREMENTS_FILE_HIERARCHY;

// Project - Comments

extern NSString * const ICDOCUMENT_PROJECT_COMMENTS;

extern NSString * const ICDOCUMENT_PROJECT_COMMENTS_NOTES;

// Packages

extern NSString * const ICDOCUMENT_PACKAGES;

extern NSString * const ICDOCUMENT_PACKAGE_UUID;

enum
{
	ICDOCUMENT_PACKAGE_TYPE_PROJECT=0,
	ICDOCUMENT_PACKAGE_TYPE_IMPORTED,
	ICDOCUMENT_PACKAGE_TYPE_REFERENCED
};

extern NSString * const ICDOCUMENT_PACKAGE_TYPE;

extern NSString * const ICDOCUMENT_PACKAGE_REFERENCE_PATH;

// Packages - Settings

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_NAME;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_IDENTIFIER;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_VERSION;

enum
{
	ICDOCUMENT_PACKAGES_SETTINGS_AUTHENTICATION_NONE=0,
	ICDOCUMENT_PACKAGES_SETTINGS_AUTHENTICATION_ROOT
};

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_AUTHENTICATION;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_RELOCATABLE;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_OVERWRITE_PERMISSIONS;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_FOLLOW_SYMBOLIC_LINKS;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_USE_HFSPLUS_COMPRESSION;

enum
{
	ICDOCUMENT_PACKAGES_SETTINGS_CONCLUSION_ACTION_NONE=0,
	ICDOCUMENT_PACKAGES_SETTINGS_CONCLUSION_ACTION_RECOMMEND_RESTART,	// Deprecated
	ICDOCUMENT_PACKAGES_SETTINGS_CONCLUSION_ACTION_REQUIRE_RESTART,
	ICDOCUMENT_PACKAGES_SETTINGS_CONCLUSION_ACTION_REQUIRE_SHUTDOWN,
	ICDOCUMENT_PACKAGES_SETTINGS_CONCLUSION_ACTION_REQUIRE_LOGOUT
};

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_CONCLUSION_ACTION;

enum
{
	ICDOCUMENT_PACKAGE_SETTINGS_LOCATION_EMBEDDED=0,
	ICDOCUMENT_PACKAGE_SETTINGS_LOCATION_CUSTOM_PATH,
	ICDOCUMENT_PACKAGE_SETTINGS_LOCATION_HTTP_URL,
	ICDOCUMENT_PACKAGE_SETTINGS_LOCATION_REMOVABLE_MEDIA
};

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_LOCATION;

extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_LOCATION_PATH;


extern NSString * const ICDOCUMENT_PACKAGE_SETTINGS_PAYLOAD_SIZE;

// Packages - Files

extern NSString * const ICDOCUMENT_PACKAGE_FILES;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_DEFAULT_INSTALL_LOCATION;

enum
{
	ICDOCUMENT_PACKAGE_FILES_PAYLOAD_TYPE_INTERNAL=0,
	ICDOCUMENT_PACKAGE_FILES_PAYLOAD_TYPE_EXTERNAL
};

extern NSString * const ICDOCUMENT_PACKAGE_FILES_PAYLOAD_TYPE;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_SPLIT_FORKS;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_HIERARCHY_SHOW_INVISIBLE;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_HIERARCHY_VERSION;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_HIERARCHY;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_TYPE;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_UID;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_GID;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_PERMISSIONS;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_EXPANDED;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_LOCATORS;

extern NSString * const ICDOCUMENT_LOCATOR_STATE;

extern NSString * const ICDOCUMENT_LOCATOR_NAME;

extern NSString * const ICDOCUMENT_LOCATOR_IDENTIFIER;

extern NSString * const ICDOCUMENT_LOCATOR_DICTIONARY;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_BUNDLE_PREINSTALL_PATH;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_BUNDLE_POSTINSTALL_PATH;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_BUNDLE_CAN_DOWNGRADE;

extern NSString * const ICDOCUMENT_PACKAGE_FILES_FILE_CHILDREN;

// Packages - Scripts

extern NSString * const ICDOCUMENT_PACKAGE_SCRIPTS;

extern NSString * const ICDOCUMENT_PACKAGE_SCRIPTS_PREINSTALL_PATH;

extern NSString * const ICDOCUMENT_PACKAGE_SCRIPTS_POSTINSTALL_PATH;

extern NSString * const ICDOCUMENT_PACKAGE_SCRIPTS_FILE_HIERARCHY;
