/*
Copyright (c) 2008-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ICPackageFileUtility.h"
#import "NSDictionary+Iceberg.h"

@implementation ICPackageFileUtility

+ (NSMutableDictionary *) defaultEmptyPackageFileDictionary
{
	NSMutableDictionary * tMutableDictionary=nil;
	
	tMutableDictionary=[NSMutableDictionary dictionary];
	
	if (tMutableDictionary!=nil)
	{
		NSMutableDictionary * tDefaultFileHierarchy;
		
		// Payload Type
		
		[tMutableDictionary setObject:[NSNumber numberWithInt:ICDOCUMENT_PACKAGE_FILES_PAYLOAD_TYPE_INTERNAL] forKey:ICDOCUMENT_PACKAGE_FILES_PAYLOAD_TYPE];
		
		// Default Install Location
		
		[tMutableDictionary setObject:@"/" forKey:ICDOCUMENT_PACKAGE_FILES_DEFAULT_INSTALL_LOCATION];
		
		// File Hierarchy
		
		tDefaultFileHierarchy=[NSMutableDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:0],ICDOCUMENT_PACKAGE_FILES_FILE_UID,
																				[NSNumber numberWithInt:80],ICDOCUMENT_PACKAGE_FILES_FILE_GID,
																				[NSNumber numberWithInt:1021],ICDOCUMENT_PACKAGE_FILES_FILE_PERMISSIONS,
																				[NSNumber numberWithInt:ICDOCUMENT_FILE_BASE_NODE],ICDOCUMENT_PACKAGE_FILES_FILE_TYPE,
																				[NSArray array],ICDOCUMENT_PACKAGE_FILES_FILE_CHILDREN,
																				@"/",ICDOCUMENT_PATH,
																				[NSNumber numberWithInteger:ICDOCUMENT_PATH_TYPE_GLOBAL],ICDOCUMENT_PATH_TYPE,
																				nil];
			
		if (tDefaultFileHierarchy!=nil)
		{
			[tMutableDictionary setObject:tDefaultFileHierarchy forKey:ICDOCUMENT_PACKAGE_FILES_FILE_HIERARCHY];
		}
		else
		{
			// Low Memory
			
			// A COMPLETER
		}
	}
	else
	{
		// Low Memory
		
		// A COMPLETER
	}

	return tMutableDictionary;
}

+ (NSMutableDictionary *) defaultPackageFileDictionary
{
	NSMutableDictionary * tMutableDictionary=nil;
	
	tMutableDictionary=[NSMutableDictionary dictionary];
	
	if (tMutableDictionary!=nil)
	{
		NSString * tPath;
		
		// Payload Type
		
		[tMutableDictionary setObject:[NSNumber numberWithInt:ICDOCUMENT_PACKAGE_FILES_PAYLOAD_TYPE_INTERNAL] forKey:ICDOCUMENT_PACKAGE_FILES_PAYLOAD_TYPE];
		
		// Default Install Location
		
		[tMutableDictionary setObject:@"/" forKey:ICDOCUMENT_PACKAGE_FILES_DEFAULT_INSTALL_LOCATION];
		
		// File Hierarchy
		
		tPath=[[NSBundle mainBundle] pathForResource:@"DefaultFileHierachy" ofType:@"plist"];
		
		if (tPath!=nil)
		{
			NSMutableDictionary * tDefaultFileHierarchy;
			
			tDefaultFileHierarchy=[NSMutableDictionary mutableDictionaryWithContentsOfFile:tPath];
			
			if (tDefaultFileHierarchy!=nil)
			{
				[tMutableDictionary addEntriesFromDictionary:tDefaultFileHierarchy];
			}
			else
			{
				// A COMPLETER - corrupted file
				
				return nil;
			}
		}
		else
		{
			// A COMPLETER - missing resources
			
			return nil;
		}
	}
	else
	{
		// A COMPLETER - low memory
	}

	return tMutableDictionary;
}

@end
