/*
Copyright (c) 2004-2010, Stephane Sudre
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the WhiteBox nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __ICPROJECTBUILDER_NOTIFICATIONS__
#define __ICPROJECTBUILDER_NOTIFICATIONS__

#import <Foundation/Foundation.h>

extern NSString * const PACKAGES_BUILDER_NOTIFICATION;

extern NSString * const PACKAGES_BUILDER_NOTIFICATION_BUILD_DID_START;

extern NSString * const PACKAGES_BUILDER_NOTIFICATION_CLEAN_DID_START;


extern NSString * const IC_BUILDER_NOTIFICATION_INFO_PID;

extern NSString * const IC_BUILDER_NOTIFICATION_INFO_PROJECT_PATH;

extern NSString * const IC_BUILDER_NOTIFICATION_INFO_EVENT_ID;

#define IC_BUILDER_NOTIFICATION_INFO_EVENT_STANDARD				0

#define IC_BUILDER_NOTIFICATION_INFO_EVENT_DEBUG				1

#define IC_BUILDER_NOTIFICATION_INFO_EVENT_BUILD_PROGRESSION	2

#define IC_BUILDER_NOTIFICATION_INFO_EVENT_CLEAN				3

#define IC_BUILDER_NOTIFICATION_REQUEST							4

extern NSString * const IC_BUILDER_NOTIFICATION_INFO_EVENT_INFORMATION_STACK;

extern NSString * const IC_BUILDER_NOTIFICATION_INFO_EVENT_INFORMATION_STACK_METADATA;

extern NSString * const IC_BUILDER_NOTIFICATION_INFO_EVENT_EXTRA_DATA;

extern NSString * const IC_BUILDER_INFORMATION_STEP;


#define IC_BUILDER_INFORMATION_STEP_PROJECT											0
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION									1
#define IC_BUILDER_INFORMATION_STEP_PACKAGE											2

#define IC_BUILDER_INFORMATION_STEP_PROJECT_BUILD_FOLDER							100
#define IC_BUILDER_INFORMATION_STEP_PROJECT_CLEAN									102

#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_BACKGROUND_IMAGE					200
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_WELCOME_MESSAGE					202
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_README_MESSAGE						204
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_LICENSE_DOCUMENT					206
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_CONCLUSION_MESSAGE					208

#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_SCRIPT								210
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_CHOICES_HIERARCHIES				211
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_INSTALLATION_VOLUME_REQUIREMENTS	212
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_JAVASCRIPT							214

#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_RESOURCES							220
#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_SCRIPTS							221

#define IC_BUILDER_INFORMATION_STEP_DISTRIBUTION_INSTALLER_PLUGINS					230

#define IC_BUILDER_INFORMATION_STEP_PACKAGE_CREATE									400
#define IC_BUILDER_INFORMATION_STEP_PACKAGE_REFERENCE								402
#define IC_BUILDER_INFORMATION_STEP_PACKAGE_IMPORT									404

#define IC_BUILDER_INFORMATION_STEP_PACKAGE_INFO									500
#define IC_BUILDER_INFORMATION_STEP_PACKAGE_PAYLOAD									502

#define IC_BUILDER_INFORMATION_STEP_SCRIPTS_PAYLOAD									600

#define IC_BUILDER_INFORMATION_STEP_PAYLOAD_ASSEMBLE								750
#define IC_BUILDER_INFORMATION_STEP_PAYLOAD_SPLIT									752
#define IC_BUILDER_INFORMATION_STEP_PAYLOAD_BOM										754
#define IC_BUILDER_INFORMATION_STEP_PAYLOAD_PAX										756


#define IC_BUILDER_INFORMATION_STEP_CLEAN											12500

#define IC_BUILDER_INFORMATION_STEP_CLEAN_OBJECT									12501


#define IC_BUILDER_INFORMATION_STEP_CURRENT											16384

#define IC_BUILDER_INFORMATION_STEP_CURRENT											16384

extern NSString * const IC_BUILDER_INFORMATION_STATE;


#define IC_BUILDER_BUILD_STATE_BEGIN		0
#define IC_BUILDER_BUILD_STATE_END_SUCCESS	1
#define IC_BUILDER_BUILD_STATE_END_FAILURE	2

extern NSString * const IC_BUILDER_INFORMATION_PACKAGE_UUID;

extern NSString * const IC_BUILDER_INFORMATION_PACKAGE_NAME;

extern NSString * const IC_BUILDER_INFORMATION_FILE_PATH;

extern NSString * const IC_BUILDER_INFORMATION_SECONDARY_FILE_PATH;

extern NSString * const IC_BUILDER_INFORMATION_SYSTEM_ERROR_DESCRIPTION;


extern NSString * const IC_BUILDER_FAILURE_REASON;

extern NSString * const IC_BUILDER_FAILURE_SECONDARY_REASON;

#define IC_BUILDER_FAILURE_REASON_UNKNOWN					0
#define IC_BUILDER_FAILURE_REASON_OUT_OF_MEMORY				1
#define IC_BUILDER_FAILURE_REASON_MISSING_INFORMATION		2
#define IC_BUILDER_FAILURE_REASON_MISSING_BUILD_DATA		3
#define IC_BUILDER_FAILURE_REASON_INCORRECT_VALUE			4

#define IC_BUILDER_FAILURE_REASON_FILE_CANNOT_BE_FOUND		10
#define IC_BUILDER_FAILURE_REASON_FILE_CANNOT_BE_CREATED	11
#define IC_BUILDER_FAILURE_REASON_FILE_CANNOT_BE_COPIED		12
#define IC_BUILDER_FAILURE_REASON_FILE_CANNOT_BE_DELETED	13
#define IC_BUILDER_FAILURE_REASON_FILE_INCORRECT_TYPE		14
#define IC_BUILDER_FAILURE_REASON_FILE_CANNOT_BE_OPENED		15

#define IC_BUILDER_FAILURE_REASON_FILE_INSUFFICIENT_PERMISSIONS_READ		20
#define IC_BUILDER_FAILURE_REASON_FILE_INSUFFICIENT_PERMISSIONS_WRITE		21
#define IC_BUILDER_FAILURE_REASON_FILE_INSUFFICIENT_PERMISSIONS_SET			22

#define IC_BUILDER_FAILURE_REASON_OPERATION_FAILED					50

#define IC_BUILDER_FAILURE_REASON_SPLIT_NON_HFS_VOLUME				100

#define IC_BUILDER_FAILURE_REASON_LICENSE_MISSING_TEMPLATE			200

#define IC_BUILDER_FAILURE_REASON_PACKAGE_SAME_NAME					300

#define IC_BUILDER_FAILURE_REASON_STRING_EMPTY						400

#define IC_BUILDER_FAILURE_REASON_REQUIREMENT_MISSING_CONVERTER		420

#define IC_BUILDER_FAILURE_REASON_REQUIREMENT_MISSING_CODE			421

#define IC_BUILDER_FAILURE_REASON_LOCATOR_MISSING_CONVERTER			422

#define IC_BUILDER_FAILURE_REASON_LOCATOR_CONVERSION_ERROR			423


#define IC_BUILDER_FAILURE_REASON_SIGNATURE_GENERIC_ERROR			500

#define IC_BUILDER_FAILURE_REASON_SIGNATURE_TIME_OUT				501

#define IC_BUILDER_FAILURE_REASON_SIGNATURE_AUTH_DENIED				502

#define IC_BUILDER_FAILURE_REASON_SIGNATURE_CERTIFICATE_NOT_FOUND	503


extern NSString * const IC_BUILDER_FAILURE_FILE_IS_FOLDER;

extern NSString * const IC_BUILDER_FAILURE_FILE_IS_TOOL;

extern NSString * const IC_BUILDER_FAILURE_TOOL_RETURN_CODE;

extern NSString * const IC_BUILDER_FAILURE_STD_ERR;

extern NSString * const IC_BUILDER_FAILURE_FILE_IS_OVERWRITE;

extern NSString * const IC_BUILDER_FAILURE_TAG_NAME;


extern NSString * const IC_BUILDER_INFORMATION_BUILD_PROGRESSION_PACKAGES_NUMBER;

#endif
